# coding: utf-8

"""
    Gate API v4

    Welcome to Gate API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.   # noqa: E501

    Contact: support@mail.gate.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class AgencyTransactionHistory(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'currency_pair': 'str',
        'total': 'int',
        'list': 'list[AgencyTransaction]'
    }

    attribute_map = {
        'currency_pair': 'currency_pair',
        'total': 'total',
        'list': 'list'
    }

    def __init__(self, currency_pair=None, total=None, list=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, int, list[AgencyTransaction], Configuration) -> None
        """AgencyTransactionHistory - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._currency_pair = None
        self._total = None
        self._list = None
        self.discriminator = None

        if currency_pair is not None:
            self.currency_pair = currency_pair
        if total is not None:
            self.total = total
        if list is not None:
            self.list = list

    @property
    def currency_pair(self):
        """Gets the currency_pair of this AgencyTransactionHistory.  # noqa: E501

        Currency pair  # noqa: E501

        :return: The currency_pair of this AgencyTransactionHistory.  # noqa: E501
        :rtype: str
        """
        return self._currency_pair

    @currency_pair.setter
    def currency_pair(self, currency_pair):
        """Sets the currency_pair of this AgencyTransactionHistory.

        Currency pair  # noqa: E501

        :param currency_pair: The currency_pair of this AgencyTransactionHistory.  # noqa: E501
        :type: str
        """

        self._currency_pair = currency_pair

    @property
    def total(self):
        """Gets the total of this AgencyTransactionHistory.  # noqa: E501

        Total  # noqa: E501

        :return: The total of this AgencyTransactionHistory.  # noqa: E501
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this AgencyTransactionHistory.

        Total  # noqa: E501

        :param total: The total of this AgencyTransactionHistory.  # noqa: E501
        :type: int
        """

        self._total = total

    @property
    def list(self):
        """Gets the list of this AgencyTransactionHistory.  # noqa: E501

        List of transaction history  # noqa: E501

        :return: The list of this AgencyTransactionHistory.  # noqa: E501
        :rtype: list[AgencyTransaction]
        """
        return self._list

    @list.setter
    def list(self, list):
        """Sets the list of this AgencyTransactionHistory.

        List of transaction history  # noqa: E501

        :param list: The list of this AgencyTransactionHistory.  # noqa: E501
        :type: list[AgencyTransaction]
        """

        self._list = list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AgencyTransactionHistory):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AgencyTransactionHistory):
            return True

        return self.to_dict() != other.to_dict()
