# coding: utf-8

"""
    Gate API v4

    Welcome to Gate API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.   # noqa: E501

    Contact: support@mail.gate.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class RepayRecordRepaidCurrency(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'currency': 'str',
        'index_price': 'str',
        'repaid_amount': 'str',
        'repaid_principal': 'str',
        'repaid_interest': 'str',
        'repaid_amount_usdt': 'str'
    }

    attribute_map = {
        'currency': 'currency',
        'index_price': 'index_price',
        'repaid_amount': 'repaid_amount',
        'repaid_principal': 'repaid_principal',
        'repaid_interest': 'repaid_interest',
        'repaid_amount_usdt': 'repaid_amount_usdt'
    }

    def __init__(self, currency=None, index_price=None, repaid_amount=None, repaid_principal=None, repaid_interest=None, repaid_amount_usdt=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, str, str, str, str, str, Configuration) -> None
        """RepayRecordRepaidCurrency - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._currency = None
        self._index_price = None
        self._repaid_amount = None
        self._repaid_principal = None
        self._repaid_interest = None
        self._repaid_amount_usdt = None
        self.discriminator = None

        if currency is not None:
            self.currency = currency
        if index_price is not None:
            self.index_price = index_price
        if repaid_amount is not None:
            self.repaid_amount = repaid_amount
        if repaid_principal is not None:
            self.repaid_principal = repaid_principal
        if repaid_interest is not None:
            self.repaid_interest = repaid_interest
        if repaid_amount_usdt is not None:
            self.repaid_amount_usdt = repaid_amount_usdt

    @property
    def currency(self):
        """Gets the currency of this RepayRecordRepaidCurrency.  # noqa: E501

        Repayment currency  # noqa: E501

        :return: The currency of this RepayRecordRepaidCurrency.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this RepayRecordRepaidCurrency.

        Repayment currency  # noqa: E501

        :param currency: The currency of this RepayRecordRepaidCurrency.  # noqa: E501
        :type: str
        """

        self._currency = currency

    @property
    def index_price(self):
        """Gets the index_price of this RepayRecordRepaidCurrency.  # noqa: E501

        Currency Index Price  # noqa: E501

        :return: The index_price of this RepayRecordRepaidCurrency.  # noqa: E501
        :rtype: str
        """
        return self._index_price

    @index_price.setter
    def index_price(self, index_price):
        """Sets the index_price of this RepayRecordRepaidCurrency.

        Currency Index Price  # noqa: E501

        :param index_price: The index_price of this RepayRecordRepaidCurrency.  # noqa: E501
        :type: str
        """

        self._index_price = index_price

    @property
    def repaid_amount(self):
        """Gets the repaid_amount of this RepayRecordRepaidCurrency.  # noqa: E501

        Repayment amount  # noqa: E501

        :return: The repaid_amount of this RepayRecordRepaidCurrency.  # noqa: E501
        :rtype: str
        """
        return self._repaid_amount

    @repaid_amount.setter
    def repaid_amount(self, repaid_amount):
        """Sets the repaid_amount of this RepayRecordRepaidCurrency.

        Repayment amount  # noqa: E501

        :param repaid_amount: The repaid_amount of this RepayRecordRepaidCurrency.  # noqa: E501
        :type: str
        """

        self._repaid_amount = repaid_amount

    @property
    def repaid_principal(self):
        """Gets the repaid_principal of this RepayRecordRepaidCurrency.  # noqa: E501

        Principal  # noqa: E501

        :return: The repaid_principal of this RepayRecordRepaidCurrency.  # noqa: E501
        :rtype: str
        """
        return self._repaid_principal

    @repaid_principal.setter
    def repaid_principal(self, repaid_principal):
        """Sets the repaid_principal of this RepayRecordRepaidCurrency.

        Principal  # noqa: E501

        :param repaid_principal: The repaid_principal of this RepayRecordRepaidCurrency.  # noqa: E501
        :type: str
        """

        self._repaid_principal = repaid_principal

    @property
    def repaid_interest(self):
        """Gets the repaid_interest of this RepayRecordRepaidCurrency.  # noqa: E501

        Interest  # noqa: E501

        :return: The repaid_interest of this RepayRecordRepaidCurrency.  # noqa: E501
        :rtype: str
        """
        return self._repaid_interest

    @repaid_interest.setter
    def repaid_interest(self, repaid_interest):
        """Sets the repaid_interest of this RepayRecordRepaidCurrency.

        Interest  # noqa: E501

        :param repaid_interest: The repaid_interest of this RepayRecordRepaidCurrency.  # noqa: E501
        :type: str
        """

        self._repaid_interest = repaid_interest

    @property
    def repaid_amount_usdt(self):
        """Gets the repaid_amount_usdt of this RepayRecordRepaidCurrency.  # noqa: E501

        Value of the repayment amount in USDT  # noqa: E501

        :return: The repaid_amount_usdt of this RepayRecordRepaidCurrency.  # noqa: E501
        :rtype: str
        """
        return self._repaid_amount_usdt

    @repaid_amount_usdt.setter
    def repaid_amount_usdt(self, repaid_amount_usdt):
        """Sets the repaid_amount_usdt of this RepayRecordRepaidCurrency.

        Value of the repayment amount in USDT  # noqa: E501

        :param repaid_amount_usdt: The repaid_amount_usdt of this RepayRecordRepaidCurrency.  # noqa: E501
        :type: str
        """

        self._repaid_amount_usdt = repaid_amount_usdt

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RepayRecordRepaidCurrency):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RepayRecordRepaidCurrency):
            return True

        return self.to_dict() != other.to_dict()
