# coding: utf-8

"""
    Gate API v4

    Welcome to Gate API  APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.   # noqa: E501

    Contact: support@mail.gate.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from gate_api.configuration import Configuration


class SwapCoin(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'coin': 'str',
        'side': 'str',
        'amount': 'str',
        'pid': 'int'
    }

    attribute_map = {
        'coin': 'coin',
        'side': 'side',
        'amount': 'amount',
        'pid': 'pid'
    }

    def __init__(self, coin=None, side=None, amount=None, pid=None, local_vars_configuration=None):  # noqa: E501
        # type: (str, str, str, int, Configuration) -> None
        """SwapCoin - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._coin = None
        self._side = None
        self._amount = None
        self._pid = None
        self.discriminator = None

        self.coin = coin
        self.side = side
        self.amount = amount
        if pid is not None:
            self.pid = pid

    @property
    def coin(self):
        """Gets the coin of this SwapCoin.  # noqa: E501

        Currency  # noqa: E501

        :return: The coin of this SwapCoin.  # noqa: E501
        :rtype: str
        """
        return self._coin

    @coin.setter
    def coin(self, coin):
        """Sets the coin of this SwapCoin.

        Currency  # noqa: E501

        :param coin: The coin of this SwapCoin.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and coin is None:  # noqa: E501
            raise ValueError("Invalid value for `coin`, must not be `None`")  # noqa: E501

        self._coin = coin

    @property
    def side(self):
        """Gets the side of this SwapCoin.  # noqa: E501

        0 - Stake  1 - Redeem  # noqa: E501

        :return: The side of this SwapCoin.  # noqa: E501
        :rtype: str
        """
        return self._side

    @side.setter
    def side(self, side):
        """Sets the side of this SwapCoin.

        0 - Stake  1 - Redeem  # noqa: E501

        :param side: The side of this SwapCoin.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and side is None:  # noqa: E501
            raise ValueError("Invalid value for `side`, must not be `None`")  # noqa: E501

        self._side = side

    @property
    def amount(self):
        """Gets the amount of this SwapCoin.  # noqa: E501

        Size  # noqa: E501

        :return: The amount of this SwapCoin.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this SwapCoin.

        Size  # noqa: E501

        :param amount: The amount of this SwapCoin.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and amount is None:  # noqa: E501
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def pid(self):
        """Gets the pid of this SwapCoin.  # noqa: E501

        DeFi-type Mining Protocol Identifier  # noqa: E501

        :return: The pid of this SwapCoin.  # noqa: E501
        :rtype: int
        """
        return self._pid

    @pid.setter
    def pid(self, pid):
        """Sets the pid of this SwapCoin.

        DeFi-type Mining Protocol Identifier  # noqa: E501

        :param pid: The pid of this SwapCoin.  # noqa: E501
        :type: int
        """

        self._pid = pid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SwapCoin):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SwapCoin):
            return True

        return self.to_dict() != other.to_dict()
